//Copyright (C) 2007 Christian Scheller

using System;
using System.Collections.Generic;
using System.Text;
using REA;

namespace Domain {
    [Serializable]
    public class Order : Contract {
        public double Total {
            get {
                double total = 0;
                foreach (OrderLine line in DecrementCommitments) {
                    total += line.Amount * line.Resource.Value;
                }
                return total;
            }
        }

        public void AddPayment(Customer customer, Currency currency) {
            IncrementCommitments.Clear();
            PaymentLine line = new PaymentLine();
            line.Amount = Total / currency.Value;
            line.Resource = currency;
            line.Provider = customer;
            IncrementCommitments.Add(line);
        }

        public Order(int id)
            : base(id) {
        }
    }
}
