﻿//Copyright (C) 2007 Christian Scheller

using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Collections.Generic;
using Domain;
using REA;
using System.Text;
using Storage;

public partial class OrderPage : System.Web.UI.Page {
    Order Order;

    protected void Page_Load(object sender, EventArgs e) {
        int orderNumber = int.Parse(Request["id"]);
        Order = Facade.GetOrders()[orderNumber];
        OrderNumberLabel.Text = Order.ID.ToString();
        OrderLineTable.Rows.Clear();
        foreach (OrderLine line in Order.DecrementCommitments) {
            HtmlTableRow row = new HtmlTableRow();
            HtmlTableCell resource = new HtmlTableCell();
            HtmlTableCell amount = new HtmlTableCell();
            HtmlTableCell recipient = new HtmlTableCell();
            HtmlTableCell fullfilled = new HtmlTableCell();
            CheckBox checkbox = new CheckBox();
            resource.InnerText = line.Resource.ToString();
            amount.InnerText = line.Amount.ToString();
            recipient.InnerText = line.Recipient.ToString();
            checkbox.Checked = line.Fulfilled;
            checkbox.Enabled = !line.Fulfilled;
            fullfilled.Controls.Add(checkbox);
            resource.Width = "164px";
            amount.Width = "83px";
            recipient.Width = "210px";
            fullfilled.Width = "58px";
            row.Cells.Add(resource);
            row.Cells.Add(amount);
            row.Cells.Add(recipient);
            row.Cells.Add(fullfilled);
            OrderLineTable.Rows.Add(row);
        }
        PaymentLineTable.Rows.Clear();
        foreach (PaymentLine line in Order.IncrementCommitments) {
            HtmlTableRow row = new HtmlTableRow();
            HtmlTableCell resource = new HtmlTableCell();
            HtmlTableCell amount = new HtmlTableCell();
            HtmlTableCell provider = new HtmlTableCell();
            HtmlTableCell fullfilled = new HtmlTableCell();
            CheckBox checkbox = new CheckBox();
            resource.InnerText = line.Resource.ToString();
            amount.InnerText = line.Amount.ToString();
            provider.InnerText = line.Provider.ToString();
            checkbox.Checked = line.Fulfilled;
            checkbox.Enabled = !line.Fulfilled;
            fullfilled.Controls.Add(checkbox);
            resource.Width = "164px";
            amount.Width = "83px";
            provider.Width = "210px";
            fullfilled.Width = "58px";
            row.Cells.Add(resource);
            row.Cells.Add(amount);
            row.Cells.Add(provider);
            row.Cells.Add(fullfilled);
            PaymentLineTable.Rows.Add(row);
        }
    }

    protected void Button1_Click(object sender, EventArgs e) {
        for(int i=0; i < OrderLineTable.Rows.Count; i++) {
            CheckBox checkbox = (CheckBox) OrderLineTable.Rows[i].Cells[3].Controls[0];
            if (checkbox.Checked && !Order.DecrementCommitments[i].Fulfilled) {
                Order.DecrementCommitments[i].Fulfill();
            }
        }
        for (int i = 0; i < PaymentLineTable.Rows.Count; i++) {
            CheckBox checkbox = (CheckBox) PaymentLineTable.Rows[i].Cells[3].Controls[0];
            if (checkbox.Checked && !Order.IncrementCommitments[i].Fulfilled) {
                Order.IncrementCommitments[i].Fulfill();
            }
        }
        Facade.SaveOrder(Order);
        Response.Redirect("orders.aspx");
    }
}